#include "testlib.h"
#include <vector>
using namespace std;

const int L = 1;
const int R = 100'000'000;
const int R_SZ = 10'000;

const int GROUPS = 3;

long long x, y, z;
long long s1, c1, s2, c2;
long long a, b;

bool solution() {
    bool is_exists = false;
    long long ans = 1e18;
    auto solve = [&](int door_wall, int num1, int num2) { // куда ставим дверь, какие обои используем
        vector<long long> sum(2, 0); // сколько какого вида обоев используеться

        if (door_wall == 0) {
            if (z < b || x < a) { // влезает ли дверь
                return;
            }
            sum[num1] -= a * b;
        }
        else {
            if (z < b || y < a) { // влезает ли дверь
                return;
            }
            sum[num2] -= a * b;
        }

        sum[num1] += 2 * x * z;
        sum[num2] += 2 * y * z;

        if (sum[0] <= s1 && sum[1] <= s2) {
            is_exists = true;
            ans = min(ans, sum[0] * c1 + sum[1] * c2);
        }
    };
    
    vector<int> mask = { 0, 0, 0 };

    for (int i = 0; i < 8; i++) {
        solve((i & 4) >> 2, (i & 2) >> 1, i & 1);
        for (auto& el : mask) {
            if (el == 0) {
                el = 1;
                break;
            }
            else {
                el = 0;
            }
        }
    }

    return is_exists;
}


int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    auto group = stoi(validator.group());
    ensure(0 <= group && group <= GROUPS);

    
    x = inf.readInt(L, R_SZ, "X");
    inf.readSpace();
    y = inf.readInt(L, R_SZ, "Y");
    inf.readSpace();
    z = inf.readInt(L, R_SZ, "Z");
    inf.readEoln();
    if (group == 1) {
        ensuref(x == y && y == z, "numbers are not equal");
    }

    
    s1 = inf.readInt(L, R, "S1");
    inf.readSpace();
    c1 = inf.readInt(L, R, "C1");
    inf.readSpace();
    s2 = inf.readInt(L, R, "S2");
    inf.readSpace();
    c2 = inf.readInt(L, R, "C2");
    inf.readEoln();

    
    a = inf.readInt(L, R_SZ, "A");
    inf.readSpace();
    b = inf.readInt(L, R_SZ, "B");
    inf.readEoln();

    if (group == 2) {
        ensuref(solution(), "solution don't exists");
    }

    inf.readEof();
}
